; ----------------------------------------------------
; Framakey Functions
; ----------------------------------------------------
; Author: sarkos
; License: GPL
; Description: Functions for Framakey Apps SDK
; Require plugin: ipicsplash, FindProcDLL, KillProcDLL
; $id=FramakeyFunctions.nsh $date=2006-05-22
; ----------------------------------------------------
; Copyright 2005-2006 Framakey Team

; Website: http://www.framakey.org

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
; ----------------------------------------------------
; Configuration chargement plugin splash
; ----------------------------------------------------

  !macro SplashInit SPLASHPLUGIN SPLASHNAME SOUNDNAME
         File /oname=$PLUGINSDIR\${SPLASHNAME} "${SPLASHNAME}"
         StrCmp ${SPLASHPLUGIN} "ipicsplash" "" Newadvsplash
         #optional
         #File /oname=$PLUGINSDIR\${SOUNDNAME} "C:\myprog\sound.wav"
         ipicsplash::show 3000 600 400 0x04025C $PLUGINSDIR\${SPLASHNAME}
         Pop $0 ; $0 has '1' if the user closed the splash screen early,
         ; '0' if everything closed normal, and '-1' if some error occured.
         Goto EndSplashInit
         Newadvsplash:
         newadvsplash::show /NOUNLOAD 2000 400 0 -1 /L $PLUGINSDIR\${SPLASHNAME}
         Pop $0 ; $0 has '1' if the user closed the splash screen early,
         ; '0' if everything closed normal, and '-1' if some error occured.
         EndSplashInit:
  !macroend

; ----------------------------------------------------
; Cherche un processus et renvoie un flag
; ----------------------------------------------------

  !macro CheckProcess EXENAME
         FindProcDLL::FindProc "${EXENAME}"
         Pop $R0
         StrCpy "$LocalProcess" $R0
  !macroend

; ----------------------------------------------------
; Cherche un processus et affiche un message
; ----------------------------------------------------

  !macro FindProcess EXENAME
         FindProcDLL::FindProc "${EXENAME}"
         Pop $R0
         StrCmp $R0 "1" "" EndFindProcess
         MessageBox MB_OK|MB_ICONINFORMATION "${FINDPROCESSMSG}"
         Abort
         EndFindProcess:
  !macroend

; ----------------------------------------------------
; Fermeture d'un processus
; ----------------------------------------------------

  !macro KillProcess EXENAME
         MessageBox MB_YESNO|MB_ICONQUESTION "${KILLPROCESSMSG}" IDYES NoKillProcessCancelAbort
         Abort ; causes uninstaller to not quit.
         NoKillProcessCancelAbort:
         KillProcDLL::KillProc "${EXENAME}"
  !macroend

; ----------------------------------------------------
; Obtenir les paramtres
; ----------------------------------------------------

  Function "GetParameters"
           Push $R0
           Push $R1
           Push $R2
           StrCpy $R0 $CMDLINE 1
           StrCpy $R1 '"'
           StrCpy $R2 1
           StrCmp $R0 '"' loop
           StrCpy $R1 ' ' ; we're scanning for a space instead of a quote
           loop:
           StrCpy $R0 $CMDLINE 1 $R2
           StrCmp $R0 $R1 loop2
           StrCmp $R0 "\" "" "nofile"
           IntOp $2 $R2 + 1
           nofile:
           ;MessageBox MB_OK "r0: $R0"
           StrCmp $R0 "" loop2
           IntOp $R2 $R2 + 1
           Goto loop
           loop2:
           IntOp $R0 $R2 - $2
           IntOp $R0 $R0 - 4
           ;MessageBox MB_OK "$R2 - $2 = $R0"
           StrCpy $R7 $CMDLINE $R0 $2 ; we save the filename
           ;MessageBox MB_OK "$2"
           loop2b:
           IntOp $R2 $R2 + 1
           StrCpy $R0 $CMDLINE 1 $R2
           ;MessageBox MB_OK "rr0: $R0"
           StrCmp $R0 " " loop2b
           StrCpy $R0 $CMDLINE "" $R2
           Pop $R2
           Pop $R1
           Exch $R0
  FunctionEnd

; ----------------------------------------------------
; Obtenir le chemin root
; Auteur : KiCHiK
; Source : http://nsis.sourceforge.net/Get_the_Root_Directory
; ----------------------------------------------------

  Function GetRoot
           Exch $0
           Push $1
           Push $2
           Push $3
           Push $4

           StrCpy $1 $0 2
           StrCmp $1 "\\" UNC
           StrCpy $0 $1
           Goto done

  UNC:
      StrCpy $2 3
      StrLen $3 $0
      loop:
      IntCmp $2 $3 "" "" loopend
      StrCpy $1 $0 1 $2
      IntOp $2 $2 + 1
      StrCmp $1 "\" loopend loop
      loopend:
      StrCmp $4 "1" +3
      StrCpy $4 1
      Goto loop
      StrCpy $0 $0 $2

  done:
       Pop $4
       Pop $3
       Pop $2
       Pop $1
       Exch $0
  FunctionEnd

; ----------------------------------------------------
; Fonctions  l'initialisation
; ----------------------------------------------------
; Prvenir plusieurs Instances
; Sources : http://www.veekee.net/wikinsis/docs/AppendiceC.html#C.11

  Function Mutex
           System::Call 'kernel32::CreateMutexA(i 0, i 0, t "myMutex") i .r1 ?e'
           Pop $R0
           StrCmp $R0 0 +3
           MessageBox MB_OK|MB_ICONEXCLAMATION "${MUTEXMSG}"
           Abort
  FunctionEnd

; ----------------------------------------------------
; Fin du script